#!/bin/bash
# ##############################################
# # User input version of Acer fan controlling #
# ##############################################

# ***************************************************************************
# Copyright (c) E2 Systems Limited 2008. This is Free Software (as in Beer),
# but please respect the copyright.
# ***************************************************************************
# YOU NEED TO SET THESE CORRECTLY
# IF YOU DON'T, THE SCRIPT WILL NOT WORK
# (AND CAN BUST YOUR OS)
# ***************************************************************************
# The Patch Addresses. Select the one appropriate for your machine.
# Acer Aspire 5315 with 512 MB of RAM
#PATCH_ADDRESS=x1F6BCEAF
# Acer Aspire 5315 with 1 GB of RAM
#PATCH_ADDRESS=x3F6BCEAF
# Acer Aspire 5315 with 2 GB of RAM
PATCH_ADDRESS=x7F6BCEAF
# ***************************************************************************

# *****************
# Initialize the fan variable
FAN=0
# *****************
# ---------------------------------------------------------------------------
function menu()
{
clear # Clear the screen

echo -en $1 # Output text from command line (or recall)

# ###########
# # Do menu #
# ###########

echo 
echo -n "                             "
echo -en '\E[0;31m'"\033[1mAcer\033[0m" # Title (Acer)
echo -n " "
echo -en '\E[0;32m'"\033[1mAspire 5315\033[0m"
echo -n " "
echo -e '\E[37;44m'"\033[1mFan Control\033[0m" # Title (white on blue bg)

# **********
# * Legend *
# **********
echo; echo

echo -e "\033[1m\033[4mLegend:\033[0m" # Bold & underlined text
tput sgr0 # Reset colours

echo -en '\E[0;34m'"\033[1m[KEY]\033[0m"
tput sgr0 # Reset colours
echo -n " the key you need to press to select the mode"

echo
echo -en ' \E[0;31m'"\033[1m--> \033[0m"
tput sgr0 # Reset colours
echo -n " the current fan mode"

echo 
echo -en ' \E[0;32m'"\033[1m--> \033[0m"
tput sgr0 # Reset colours
echo -n " the last menu item selected"

# *****************
# * Aviable modes *
# *****************
echo; echo

echo -e "\033[1m\033[4mAviable modes:\033[0m" # Bold & underlined text
tput sgr0 # Reset colours

#
# Ignition off
#
if [ "$FAN" == "0" ]
	then
		echo -en '\E[0;31m'"\033[1m--> \033[0m" # Output arrow if this is the current mode
		tput sgr0 # Reset colours
fi

if [ "$2" == "1" ]
	then
		echo -en '\E[0;32m'"\033[1m--> \033[0m" # Output arrow if this was the last key pressed
		tput sgr0 # Reset colours
fi

echo -n "Ignition "
echo -en '\E[0;34m'"\033[1m[O]\033[0m"   # Highlight the choice character
tput sgr0 # Reset colours
echo -n "ff"

#
# Cluth down
#
echo

if [ "$FAN" == "1" ]
	then
		echo -en '\E[0;31m'"\033[1m--> \033[0m" # Output arrow if this is the current mode
		tput sgr0 # Reset colours
fi

if [ "$2" == "2" ]
	then
		echo -en '\E[0;32m'"\033[1m--> \033[0m" # Output arrow if this was the last key pressed
		tput sgr0 # Reset colours
fi

echo -n "Cluth "
echo -en '\E[0;34m'"\033[1m[D]\033[0m" # Highlight the choice character
tput sgr0 # Reset colours
echo "own"

#
# First gear
#
if [ "$FAN" == "2" ]
	then
		echo -en '\E[0;31m'"\033[1m--> \033[0m" # Output arrow if this is the current mode
		tput sgr0 # Reset colours
fi

if [ "$2" == "3" ]
	then
		echo -en '\E[0;32m'"\033[1m--> \033[0m" # Output arrow if this was the last key pressed
		tput sgr0 # Reset colours
fi

echo -en '\E[0;34m'"\033[1m[F]\033[0m" # Highlight the choice character
tput sgr0 # Reset colours
echo "irst gear"

#
# Second gear
#
if [ "$FAN" == "3" ]
	then
		echo -en '\E[0;31m'"\033[1m--> \033[0m" # Output arrow if this is the current mode
		tput sgr0 # Reset colours
fi

if [ "$2" == "4" ]
	then
		echo -en '\E[0;32m'"\033[1m--> \033[0m" # Output arrow if this was the last key pressed
		tput sgr0 # Reset colours
fi

echo -en '\E[0;34m'"\033[1m[S]\033[0m" # Highlight the choice character
tput sgr0 # Reset colours
echo "econd gear"

#
# Third gear
#
if [ "$FAN" == "4" ]
	then
		echo -en '\E[0;31m'"\033[1m--> \033[0m" # Output arrow if this is the current mode
		tput sgr0 # Reset colours
fi

if [ "$2" == "5" ]
	then
		echo -en '\E[0;32m'"\033[1m--> \033[0m" # Output arrow if this was the last key pressed
		tput sgr0 # Reset colours
fi

echo -en '\E[0;34m'"\033[1m[T]\033[0m" # Highlight the choice character
tput sgr0 # Reset colours
echo "hird gear"

#
# Show this menu again
#
if [ "$2" == "6" ]
	then
		echo -en '\E[0;32m'"\033[1m--> \033[0m" # Output arrow if this is the current mode
		tput sgr0 # Reset colours
fi

echo -en '\E[0;34m'"\033[1m[H]\033[0m" # Highlight the choice character
tput sgr0 # Reset colours
echo "elp (show this again)"

#
# Exit
#
echo -en '\E[0;34m'"\033[1m[E]\033[0m" # Highlight the choice character
tput sgr0 # Reset colours
echo "xit"


# ##################################################
# # Automatically read user input (using function) #
# ##################################################
readInput
}
# ---------------------------------------------------------------------------
function readInput ()
{
# ###################
# # Do choice input #
# ###################

echo
echo -n "Please enter the "
echo -en '\E[0;34m'"\033[1m[HIGHLIGHTED]\033[0m" # Highlight the text
tput sgr0 # Reset colours
echo -n " character of the mode you want to use"
tput sgr0 # Reset colours
echo -n ": "

read -n 1 new_mode # Read the new mode

# ###############
# # Parse input #
# ###############
echo 
case "$new_mode" in
# Accepting both upper and lowercase inputs (users are lazy)
	"O" | "o" )
		mempat -x 2828 $PATCH_ADDRESS /dev/mem # Do memory hack for mode
		FAN=0 # Set FAN mode
		menu "Mode change: "'\E[0;36m'"\033[1m[IGNTION OFF]\033[0m" 1
		;;
	"D" | "d" )
		mempat -x 3232 $PATCH_ADDRESS /dev/mem # Do memory hack for mode
		FAN=1 # Set FAN mode
		menu "Mode change: "'\E[0;35m'"\033[1m[CLUTCH DOWN]\033[0m" 2
		;;
	"F" | "f" )
		mempat -x 4242 $PATCH_ADDRESS /dev/mem # Do memory hack for mode
		FAN=2 # Set FAN mode
		menu "Mode change: "'\E[0;34m'"\033[1m[FIRST GEAR]\033[0m" 3
		;;
	"S" | "s" )
		mempat -x 4a4a $PATCH_ADDRESS /dev/mem # Do memory hack for mode
		FAN=3 # Set FAN mode
		menu "Mode change: "'\E[0;33m'"\033[1m[SECOND GEAR]\033[0m" 4
		;;
	"T" | "t" )
		mempat -x 5252 $PATCH_ADDRESS /dev/mem # Do memory hack for mode
		FAN=4 # Set FAN mode
		menu "Mode change: "'\E[0;31m'"\033[1m[THIRD GEAR]\033[0m" 5
		;;
	"H" | "h" )
		menu '\E[0;32m'"\033[1m[HELP]\033[0m" 6 # Green text, recall script
		;;
	"E" | "e" )
		clear # Clear the screen
		echo -en '\E[0;34m'"\033[1m[EXIT]\033[0m"
		tput sgr0 # Reset colours
		echo -en " from Fan Control"
		echo; echo
		exit 0 # Exit
		;;
	* )
		# Zero input
		echo -e '\E[0;31m'"\033[1m[INVALID KEY]\033[0m" # Echo error message
		tput sgr0 # Reset clours
		readInput # Re-read user input
		;;
esac
}
# ---------------------------------------------------------------------------
# ---------------------------------------------------------------------------
clear # Clear the screen

# #########################################
# # Check whether the user is root (sudo) #
# #########################################
if [ "$(whoami)" != "root" ]; then
	echo -e '\E[0;31m'"\033[1mYou need to be \033[0m"'\E[0;32m'"\033[1mroot\033[0m"'\E[0;31m'"\033[1m to use this file.\033[0m" # Output error message
	tput sgr0 # Reset colours
	echo -e '\E[0;32m'"\033[1mStart this as \033[0m"'\E[0;0m'"sudo ./acer_fancontrol.sh"'\E[0;32m'"\033[1m and enter your password.\033[0m" # Sudo info
	tput sgr0 # Reset colours
	echo -e "\033[1mIt will work after that :)\033[0m" # :)
	tput sgr0 # Reset colours
	
	sleep 5 # Wait 5 seconds
	exit 1 # Terminate
fi

# ###########################################
# # Automatically shut down fan on startup  #
# # (essential for script to work properly) #
# ###########################################
mempat -x 2828 $PATCH_ADDRESS /dev/mem # Shut down fan
FAN=0 # Set FAN mode
# ###########################################

# ################################
# # Output menu (using function) #
# ################################
menu
# ---------------------------------------------------------------------------
